/* lesanne: KONN                                                          */
/* Autor: Heno Ivanov                                                      */
/* Testitud: GCC 3.2 / Win32                                               */

#include <stdio.h>
#include <assert.h>

#define R 52 /* maksimaalne ridade arv */
#define V 52 /* maksimaalne veergude arv */
static int tiikr; /* tiigi ridade arv */
static int tiikv; /* tiigi veergude arv */
static int konnr; /* konna algrida */
static int konnv; /* konna algveerg */
static int kiilr; /* kiili rida */
static int kiilv; /* kiilid veerg */
static int roosid[R*V]; /* tiigi kaart */
static int tiik[R*V*15*15]; /* graafi tipud */

/* algvrtustab graafi */
tiikinit() {
    int i;
    for (i = 0;i < (R*V*15*15); i++) {
        tiik[i] = 9999999;
    }
}

/* graafi tipp, mis vastab konna asumisele punktis (r,v) kiirusel (rv,vv) */
#define tp(r,v,rv,vv) ((r)*V*15*15 + (v)*(15*15) + (rv+7)*15 + (vv+7))

/* laiuti lbimiseks vajalik tippude jrjekord */
#define qsize 1000000 /* maksimaalne jrjekorra suurus */
static int queue[qsize]; /* jrjekorra elemendid */
static int wp = 0; /* kirjutuspositsioon */
static int rp = 0; /* lugemispositsioon */

/* lisab elemendi jrjekorra lppu */
void enqueue(int i) {
    queue[wp] = i;
    wp = (wp + 1) % qsize;
    assert(wp != rp);
#ifdef DEBUG
    printf("qsize = %d\n", (wp - rp) % qsize);
#endif
}

/* loeb elemendi jrjekorra algusest */
int rqueue() {
    int tmp;
    tmp = queue[rp];
    rp = (rp + 1) % qsize;
    return tmp;
}

/* loeb sisendandmed */
void loesisend() {
    FILE *f;
    int i, j;
    char tbuf[V + 1];

    f = fopen("KONN.SIS", "r");
    fscanf(f, "%d %d\n", &tiikr, &tiikv);

    for (i = 0; i < tiikr; i++) {
        fscanf(f, "%s\n", tbuf);
        for (j = 0;j < tiikv; j++) 
            if (tbuf[j] == '0')
                roosid[V*i+j] = 0;
            else 
                roosid[V*i+j] = 1;
    }
    fscanf(f, "%d %d\n", &konnr, &konnv);
    fscanf(f, "%d %d\n", &kiilr, &kiilv);

    fclose(f);
}

/* ttleb graafi tipu koht */
tootle(int koht ) {
    int r, v, rv, vv;
    int i, j;
    int uusr, uusv;

    /* tipule vastava ruudu koordinaadid */
    r = koht / (V * 15 * 15);
    v = (koht / (15 * 15)) % V;
    /* tipule vastav konna kiirusvektor */
    rv = ((koht / 15) % 15) - 7;
    vv = ((koht % 15)) - 7;
#ifdef DEBUG
    printf("ttlen tippu: (%d, %d), kiirus (%d %d)\n", r, v, rv, vv);
#endif

    /* vaatame lbi kik vimalikud kiirendused ja pidurdused */
    for (i = -1; i <= 1 ; i++) 
        for (j = -1; j <= 1; j++) {
            if (rv + i < -7 || rv + i > 7)
                continue;
            if (vv + j < -7 || vv + j > 7)
                continue;
            uusr = r + rv + i;
            uusv = v + vv + j;
            if (uusr < 0 || uusr >= tiikr)
                continue;
            if (uusv < 0 || uusv >= tiikv)
                continue;
            if (roosid[uusr*V + uusv] == 0)
                continue;
            if (tiik[tp(uusr,uusv,rv+i,vv+j)] <= tiik[koht] + 1)
                continue;
            tiik[tp(uusr,uusv,rv+i,vv+j)] = tiik[koht] + 1;
            enqueue(tp(uusr,uusv,rv+i,vv+j));
        }
}

/* siia salvestame leitud vastuse */
int vastusr[R*V];
int vastusv[R*V];

/* taastame tagurpidi liikudes konna tee kiilini */
void taastatee(koht) {
    int r, v, rv, vv;
    int i, j;
    int uusr, uusv;

    /* tipule vastava ruudu koordinaadid */
    r = koht / (V * 15 * 15);
    v = (koht / (15 * 15)) % V;
    /* tipule vastav konna kiirusvektor */
    rv = ((koht / 15) % 15) - 7;
    vv = ((koht % 15)) - 7;

    /* kuni oleme tagurdamisega judnud konna lhepunkti */
    while (tiik[koht] != 0) {
        /* vaatame lbi kik vimalikud kiirendused ja pidurdused */
        for (i = -1; i <= 1; i++)
            for (j = -1; j <= 1; j++) {
                uusr = r - rv ;
                uusv = v - vv ;
#ifdef DEBUG
                printf("koht hinnaga: %d\n", tiik[tp(uusr,uusv,rv+i,vv+j)]);
#endif
                if (uusr < 0 || uusr >= tiikr)
                    continue;
                if (uusv < 0 || uusv >= tiikv)
                    continue;
                if (rv - i < -7 || rv - i > 7)
                    continue;
                if (vv - j < -7 || vv - j > 7)
                    continue;
                if (tiik[tp(uusr,uusv,rv-i,vv-j)] != tiik[koht] - 1)
                    continue;
                koht = tp(uusr,uusv,rv-i,vv-j);
                r = uusr;
                v = uusv;
                rv -= i;
                vv -= j;
#ifdef DEBUG
                printf("samm (%d %d), kiirus (%d %d)\n", r+1, v+1, rv, vv);
#endif
                vastusr[tiik[koht]] = r+1;
                vastusv[tiik[koht]] = v+1;
                goto next;
            }
next:
    }
}

int main() {
    int i;
    FILE *fo;
    tiikinit();
    loesisend();

    /* konna algasukoha kaugus on 0 */
    tiik[tp(konnr-1,konnv-1,0,0)] = 0;

    /* standardne laiutiotsimine */
    enqueue(tp(konnr-1,konnv-1,0,0));
    while (wp != rp) {
        tootle(rqueue());
    }

    taastatee(tp(kiilr-1,kiilv-1,0,0));
    fo = fopen("KONN.VAL", "w");

    if (tiik[tp(kiilr-1,kiilv-1,0,0)] == 0) {
        fprintf(fo, "0\n");
    } else {
        fprintf(fo, "%d\n", tiik[tp(kiilr-1,kiilv-1,0,0)] - 1);
    }

    for (i = 0; i < tiik[tp(kiilr-1,kiilv-1,0,0)]; i++) {
        fprintf(fo, "%d %d\n", vastusr[i], vastusv[i]);
    }
    fclose(fo);
    return 0;
}
