// lesanne: VEER
// Autor: Kristo Tammeoja
// Testitud: FPC 1.0.10 / Win32

const
    SIS_FAIL = 'VEER.SIS';
    VAL_FAIL = 'VEER.VAL';

    MAX_RIDU = 10;
    MAX_VEERGE = 10;
    // Maksimaalne klastamata ruutude arv
    KOIK_KAIMATA = MAX_RIDU * MAX_VEERGE;

    NORTH = 'N';
    EAST = 'E';
    SOUTH = 'S';
    WEST = 'W';

    // erinevad liikumissuunad
    SUUND_TAHT : array[1..4] of char = (EAST, NORTH, SOUTH, WEST);
    SUUND_DX : array[1..4] of integer = (1, 0, 0, -1);
    SUUND_DY : array[1..4] of integer = (0, -1, 1, 0);
    SUUND_VASTU_TAHT : array[1..4] of char = (WEST, SOUTH, NORTH, EAST);

type
    t_taring = record
        // laual seisva tringu phjapoolne, vastu lauda olev
        // ja lnepoolne klg
        N, all, W : integer;
    end;

    t_tee = record
        pikkus : integer;
        // igal vljal on
        tee : array[1..MAX_RIDU*MAX_VEERGE*2*4] of char;
        suund : array[1..MAX_RIDU*MAX_VEERGE*2*4] of integer;
    end;

    // Jada genereerimisel kasutatavad andmed (iga ruudu kohta)
    t_stat = record
        // Mitu korda on sellest ruudust le kidud
        kaidud_cnt : integer;
        // iga phjapoole jva silmade kohta
        // klastamata ruutude arv tol korral...
        eelmine_kaimata_cnt : array[1..6] of integer;
        // ... ja viimati kasutatud suund
        eelmine_suund : array[1..6] of integer;
        yleeelmine_suund : array[1..6] of integer;
    end;

var
    // Sisendandmed
    R, V : integer;
    r0, v0, N_silmi_0 : integer;
    laud : array[0..MAX_RIDU+1, 0..MAX_VEERGE+1] of integer;

    // Andmed, mida kasutatakse veeretamise jada genereerimisel
    tee : t_tee;

    kaimata_ruute : integer;
    stat : array[1..MAX_RIDU, 1..MAX_VEERGE] of t_stat;

    parim_pikkus : integer;

    // Vastuse hoidmiseks
    vastus : t_tee;


//============== MEETODID TRINGU VEERETAMISEKS ==============

// Veeretab tringut 't' suunas 's'
procedure veereta(suund : char; var t : t_taring);
var l : integer;
begin
    case suund of
    NORTH:
        begin
            l := t.all;
            t.all := t.N;
            t.N := 7 - l;
        end;
    EAST:
        begin
            l := t.all;
            t.all := 7 - t.W;
            t.W := l;
        end;
    SOUTH:
        begin
            l := t.all;
            t.all := 7 - t.N;
            t.N := l;
        end;
    WEST:
        begin
            l := t.all;
            t.all := t.W;
            t.W := 7 - l;
        end;
    else
        writeln('veereta: vale parameeter suund=''', suund, '''');
    end;
end; //veereta

// Keerab tringut pripeva 90 kraadi.
procedure keera90(var t : t_taring);
var l : integer;
begin
    l := t.N;
    t.N := t.W;
    t.W := 7 - l;
end; // keera90

// Tidab tringu vlja 'W', kui on ette antud 'N' ja 'all'
procedure leia_W(var taring : t_taring);
var
    l, k, t : integer;
    mudel : t_taring; // abitring, mida saab veeretada
begin
    // proovime lbi kik variandid
    for l := 1 to 6 do begin
        // need, mison juba teada, ei sobi
        if l = taring.all then continue;
        if l = 7 - taring.all then continue;
        if l = taring.N then continue;
        if l = 7 - taring.N then continue;

        // konstrueerime mudeli
        mudel := taring;
        mudel.W := l;

        // keerame niimodi, et 1 saaks NORTH suunas veeretades ktte
        if (mudel.W = 1) or (mudel.W = 7-1) then veereta(WEST, mudel);

        // keerame 1-e alla
        for k := 1 to 4 do begin
            if mudel.all = 1 then
                // keerame 2-e ette
                for t := 1 to 4 do begin
                    // 'l' sobib 'W'-ks
                    if (mudel.N = 2) and (mudel.W = 3) then begin
                        taring.W := l;
                        exit;
                    end;

                    keera90(mudel);
                end;

            veereta(NORTH, mudel);
        end;
    end;

    writeln('leia_W: mingi kahtlane tring oli ',
            'N=', taring.N,
            ' all=', taring.all);
end; //leia_W

//==================== ALGORITM =====================

procedure loe_andmed;
var
    fail : text;
    rl, vl : integer;
begin
    assign(fail, SIS_FAIL); reset(fail);

    readln(fail, R, V);

    // tidame laua 0-dega, et serva peale liikuda ei saaks
    for rl := 0 to R+1 do
        for vl := 0 to V+1 do
            laud[rl, vl] := 0;

    // loeme laua andmed
    for rl := 1 to R do begin
        for vl := 1 to V do
            read(fail, laud[rl, vl]);
        readln(fail);
    end;

    // lejnud andmed
    readln(fail, r0, v0, N_silmi_0);

    close(fail);
end; //loe_andmed

procedure minek(sammu_nr : integer; rr, vv : integer; t : t_taring);
var
    loigata : boolean;
    suund : integer;
    taring : t_taring;

    tmp__eelmine_cnt : integer;
    tmp__yleeelmine_suund : integer;
begin
    // kas siia tohtis ldse kia
    if laud[rr, vv] <> t.all then exit;

    // parandame kimata ruutude arvu
    inc(stat[rr, vv].kaidud_cnt);
    if stat[rr, vv].kaidud_cnt = 1 then dec(kaimata_ruute);

    loigata := false;

    // kui on uus lhem vastus
    // (teid genereeritakse thestikulises jrjekorras)
    if kaimata_ruute = 0 then
        if parim_pikkus > tee.pikkus then begin
            parim_pikkus := tee.pikkus;
            vastus := tee;
            loigata := true;
        end;

    // kui sellest harust niikuinii paremat lahendust ei tule,
    // sest samme tuleb liiga palju
    if sammu_nr + kaimata_ruute >= parim_pikkus then loigata := true;

    // kui veeredes juti tagasi sellisesse kohta ja sellises asendis
    // kui varem oldi (st tehti mingi ring), kuid seda ringi teispidi
    // tehes oleks tee kirjeldus thestikulises jrjestuses eespool...
    if stat[rr, vv].eelmine_suund[t.N] >= 1 then
        if   SUUND_TAHT[stat[rr, vv].eelmine_suund[t.N]]
           > SUUND_VASTU_TAHT[tee.suund[tee.pikkus]]
        then
            loigata := true;

    // kui veeredes juti teist korda samas asendis sellele ruudule,
    // st tehti kaks seda ruutu sisaldavat tsklit, siis pidi tskkel,
    // mille esimene samm on thestikus eespool, olema ka varem tehtud...
    if     (stat[rr, vv].yleeelmine_suund[t.N] >= 1)
       and (stat[rr, vv].eelmine_suund[t.N] >= 1)
    then
        if   stat[rr, vv].yleeelmine_suund[t.N]
           > stat[rr, vv].eelmine_suund[t.N]
        then
            loigata := true;

    // kui eelmine kord selles asendis antud ruudule juti, siis oli
    // samapalju ruute lbi kimata (st vahepeal ei tehtud midagi)
    if stat[rr, vv].eelmine_kaimata_cnt[t.N] = kaimata_ruute then
        loigata := true;

    // kui on mtet edasi teha
    if not loigata then begin
        tmp__eelmine_cnt := stat[rr, vv].eelmine_kaimata_cnt[t.N];
        tmp__yleeelmine_suund := stat[rr, vv].yleeelmine_suund[t.N];
        stat[rr, vv].yleeelmine_suund[t.N] :=
            stat[rr, vv].eelmine_suund[t.N];

        // jtame meelde antud asendi jaoks, mitu ruutu on lbi kimata
        stat[rr, vv].eelmine_kaimata_cnt[t.N] := kaimata_ruute;

        // genereerime vimalikke jtke, thestikulises jrjekorras
        inc(tee.pikkus);

        for suund := 1 to 4 do begin
            // et mni jrgmine kord selles asendis samale ruudule sattudes
            // mingis "viksema" thega suunas ei mindaks
            stat[rr, vv].eelmine_suund[t.N] := suund;

            // veeretame tringu igesse asendisse
            taring := t;
            veereta(SUUND_TAHT[suund], taring);

            // mrgime liikumise ra
            tee.tee[tee.pikkus] := SUUND_TAHT[suund];
            tee.suund[tee.pikkus] := suund;

            minek(sammu_nr+1,
                  rr+SUUND_DY[suund],
                  vv+SUUND_DX[suund],
                  taring);
        end;

        dec(tee.pikkus);

        stat[rr, vv].eelmine_kaimata_cnt[t.N] := tmp__eelmine_cnt;
        stat[rr, vv].eelmine_suund[t.N] :=
            stat[rr, vv].yleeelmine_suund[t.N];
        stat[rr, vv].yleeelmine_suund[t.N] := tmp__yleeelmine_suund;
    end; // ei ligatud

    // muudame kimata ruutude arvu endiseks
    if stat[rr, vv].kaidud_cnt = 1 then inc(kaimata_ruute);
    dec(stat[rr, vv].kaidud_cnt);
end; //minek

procedure lahenda;
var
    rl, vl, n, s : integer;
    t : t_taring;
    // nitab, kui pikka teed otsitakse
    l : integer;
    // hinnangulised pikkused
    min_p, max_p : integer;
begin
    // sellest lhemat vastust enam olla ei saa
    min_p := R*V-1;
    // vhemalt sellest viksema pikkusega vastus on vimalik genereerida
    max_p := R*V*4;

    // Lahendame lesannet suurendades maksimaalset lubatavat tee pikkust
    // iteratiivselt
    for l := 0 to 10 do begin
        // proovitav maksimaalne pikkus...
        parim_pikkus := ((max_p-min_p) * l) div 10 + min_p;
        // ...kuna algoritm leiab vaid 'parim_pikkus'-sest lhemaid teid
        parim_pikkus := parim_pikkus+1;

        // Muutujate algvrtustamine
        for rl := 1 to R do
            for vl := 1 to V do begin
                stat[rl, vl].kaidud_cnt := 0;
                for n := 1 to 6 do begin
                    stat[rl, vl].eelmine_kaimata_cnt[n] := KOIK_KAIMATA;
                    // esimene suund, mida vaatama hakata, on 1
                    stat[rl, vl].eelmine_suund[n] := -1;
                    stat[rl, vl].yleeelmine_suund[n] := -1;
                end;
            end;

        kaimata_ruute := R*V;

        // genereeritav tee
        tee.pikkus := 0;
        vastus.pikkus := -1;
        // ja taringu algseis
        t.all := laud[r0, v0];
        t.N := N_silmi_0;
        leia_W(t);

        // genereerima
        minek(0, r0, v0, t);

        // kui vastus saadi teada
        if vastus.pikkus > 0 then break;
    end;
end; // lahenda

procedure kirjuta_vastus;
var
    l : integer;
    fail : text;
begin
    assign(fail, VAL_FAIL); rewrite(fail);
    writeln(fail, vastus.pikkus);
    for l := 1 to vastus.pikkus do
        write(fail, vastus.tee[l]);
    writeln(fail);
    close(fail);
end; //kirjuta_vastus

begin
    loe_andmed;
    lahenda;
    kirjuta_vastus;
end.
